/* 
 * $Id: XMLTool.h,v 1.6 2005/10/19 14:05:44 ozawa Exp $
 *
 * Copyright 2005- ONGS Inc. All rights reserved.
 * 
 * author: Masanori OZAWA (ozawa@ongs.co.jp)
 * version: $Revision: 1.6 $
 *
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 *   1. Redistributions of source code must retain the above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice, this list of conditions and the following disclaimer in the
 *      documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY ONGS INC ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL ONGS INC OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * The views and conclusions contained in the software and documentation are
 * those of the authors and should not be interpreted as representing official
 * policies, either expressed or implied, of the ONGS Inc.
 * 
 */

#ifndef ___XMLTOOL_H
#define ___XMLTOOL_H

#include "libxml/tree.h"
#include "libxml/xpath.h"
#include "libxslt/xslt.h"
#include "libxslt/transform.h"

namespace XDTP {

class XMLTool
{
public:
	XMLTool();
	virtual ~XMLTool();

    /**
     * ʣؤ˸٤Element٤ޤ
     * ¸Element¸ߤϡ¸ߤʤElementΤߤޤ
     * 
     * @param aDocument
     *            оݤDOM ֥
     * @param aXPath
     *            ʣؤ˸٤Element̤XPath
     *            ĤγؤʣElementꤹ褦ʤȤϤǤޤ(: /e1/e2/e3/e4 )
     * @return ȤϺǲؤ ElementԤȤ null
     */
    xmlNodePtr createElements(xmlDocPtr aDocument, const Glib::ustring& aXPath);
    
    /**
     * XMLեΥ󥳡ǥ󥰤ޤ
     * 
     * @param aFile XMLե̾
     * @return 󥳡ǥ
     */
    std::string getEncoding(const Glib::ustring& aFile);

    /**
     * NodeXPathNodeΰޤ
     * 
     * @param aNode
     *            õNode
     * @param aXPath
     *            NodeXPath
     * @return Nodeΰݻ륪֥ȡ
     *         פˤʤäʳǡxmlXPathFreeObjectɬפޤ
     */
    xmlXPathObjectPtr getNodeList(xmlNodePtr aNode, const Glib::ustring& aXPath);

    /**
     * Nodeľ¸ߤTextޤ
     * 
     * @param aNode
     *            TextޤNode
     * @return TextʸText¸ߤʤ϶ʸ
     */
    Glib::ustring getText(xmlNodePtr aNode);

    /**
     * NodeAttributeåޤ
     * 
     * @param aNode
     *            åоݤNode
     * @return Attributeξ true
     */
    bool isAttribute(xmlNodePtr aNode);

    /**
     * NodeCommentåޤ
     * 
     * @param aNode
     *            åоݤNode
     * @return Commentξ true
     */
    bool isComment(xmlNodePtr aNode);

    /**
     * NodeElementåޤ
     * 
     * @param aNode
     *            åоݤNode
     * @return Elementξ true
     */
    bool isElement(xmlNodePtr aNode);

    /**
     * NodeTextåޤ
     * 
     * @param aNode
     *            åоݤNode
     * @return Textξ true
     */
    bool isText(xmlNodePtr aNode);

    /**
     * NodeľTextꤷޤ
     * 
     * @param aNode
     *            TextꤹNode
     * @param aText
     *            ꤹText
     * @return  true
     */
    bool setText(xmlNodePtr aNode, const Glib::ustring& aText);

    /**
     * DOMɥȤXSLTѤѴޤ
     * 
     * @param aDocument
     *            ѴDOMɥ
     * @param aXSLFile
     *            XSLե
     * @return ѴDOMɥȡפˤʤäʳxmlFreeDocɬפޤ
     */
    xmlDocPtr transform(xmlDocPtr aDocument, const Glib::ustring& aXSLFile);

    /**
     * DOMɥȤXSLTѤѴޤ
     * 
     * @param aDocument
     *            ѴDOMɥ
     * @param aXSL
     *            XSL֥
     * @return ѴDOMɥȡפˤʤäʳxmlFreeDocɬפޤ
     */
    xmlDocPtr transform(xmlDocPtr aDocument, xsltStylesheetPtr aXSL);
};

};

#endif
